#-*- coding: utf-8 -*-
#
# Pokemon_k_plus_proches_voisins.py

# https://matplotlib.org/gallery.html
# https://python-graph-gallery.com/134-how-to-avoid-overplotting-with-python/


import matplotlib.pyplot as plt 
from os import chdir
from os import listdir

# Se déplacer dans le dossier en cours si besoin
path = r'P:\PRO\USB\NSI\NSI ALGO AVANCE\TRAVAUX PYTHON'
chdir(path)


import csv

from math import sqrt

def distance_cible(donnee):
    distance = sqrt( ( int(donnee[1])-cible[0] )**2 + \
                     xxxxxxxxxxxxxxxxxxxxxxx          \
                ) 
    return distance


## Lecture du Dataset au format CSV
# On créer la liste vide
table=[]
 
# Lecture de la table csv, le résultat est dans une 
# liste de liste
with open('xxxxxxxxxxx', encoding="utf8") as myFile:
    reader = csv.reader(myFile,delimiter=';')
    for row in reader:  
        table.append(row)	
        
# for x in range(len(table)):
#     print(table[x])

print()
print()

## Préparation des données à tracer
# Préparation des données à répartir dans deux classes
liste_Pokemon_g1 = [ [ int(x[1])  for x in table if x[3]=='Eau'] , \
                     [ int(x[2])  for x in table if x[3]=='Eau'] ]
liste_Pokemon_g2 = [ [ xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx , \
                     [ xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx ]

Pokemon_inconnu = [ 75, 90 ]                     

# Préparation des options pour le tracé matplotlib
data = [liste_Pokemon_g1, liste_Pokemon_g2, Pokemon_inconnu]
colors = ("blue", "red", "green")
groups = ("Eau", "Psy", "?")
forme_marqueur = ("s","p","H")

## Creation du tracé
# https://pythonspot.com/matplotlib-scatterplot/

# Création de l'objet figure pour matplotlib
fig = plt.figure()
fig.patch.set_facecolor('white')

# Tracé du nuage de points, scatter plot
# On utilise l'itération parallèle avec la fonction zip
for data, color, group, marque in zip(data, colors, groups, forme_marqueur):
    x, y = data
    plt.scatter(x, y, alpha=0.8, c=color, marker=marque, edgecolors='none', s=30, label=group)

# Préparation du titre
plt.title("Classification des Pokemons",fontsize = 25,color = "#00008B")
# Choix de la position de la légende dans le graphique
plt.legend(loc=2)
# Préparation des labels en abscisses et ordonnées
plt.xlabel("Points de vie",fontsize = 16,color = "#00008B")
plt.ylabel("Points d'attaque",fontsize = 16,color = "#00008B")
# Tout est prêt On trace le graphique
plt.show()   



# Traitement de classification du Pokémon inconnu
cible = Pokemon_inconnu

# On supprime la première valeur de la table qui correspond au descripteur
table.pop(0)

# On tri la table avec une fonction définie spécifiquement par key
# Le tri avec la fonction sorted construit une nouvelle liste la liste 
# d'origine n'est pas modifiée
table_triee = sorted(table, key = distance_cible)


# Création de la liste des k plus proches voisins







# Conclusion de quelle classe est le pokemon inconnu ? 

